// RegFlush.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int printUsage()
{
	_tprintf(TEXT("RegFlush </u>\r\n/u (optional) run in silent mode, no UI messages.\r\n"));
	return -1;
}


int _tmain(int argc, TCHAR *argv[], TCHAR *envp[])
{
	BOOL silent=FALSE;
	TCHAR* steps[]={ TEXT("machine"),TEXT("user"),TEXT("users"),TEXT("classes") };
	DWORD step=0;
	DWORD err=0;

	switch (argc)
	{
	case 1:
		break;
	case 2:
		if (_tcsicmp(argv[1],TEXT("/u")))
			silent=TRUE;
		else
			return printUsage();
		break;
	case 3:
		return printUsage();
	}

	err=RegFlushKey(HKEY_LOCAL_MACHINE);

	if (err==ERROR_SUCCESS)
	{
		step++;
		err=RegFlushKey(HKEY_CURRENT_USER);
	}

	if (err==ERROR_SUCCESS)
	{
		step++;
		err=RegFlushKey(HKEY_USERS);
	}

	if (err==ERROR_SUCCESS)
	{
		step++;
		err=RegFlushKey(HKEY_CLASSES_ROOT);
	}

	if (err==ERROR_SUCCESS)
	{
		if (!silent)
			MessageBox(NULL,TEXT("Registry successfully saved"),TEXT("RegFlush"),MB_OK);
		return 0;
	}

	TCHAR msg[256];

	_stprintf(msg,TEXT("Error %d(0x%08x) saving %s registry"),err,err,steps[step]);

	if (!silent)
		MessageBox(NULL,msg,TEXT("RegFlush"),MB_OK|MB_ICONSTOP);

	RETAILMSG(1,(msg));
	return -1;
}
