// LoadCPU.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int printUsage()
{
	_tprintf(TEXT("usage: LoadCPU time percentage priority\r\n"));
	_tprintf(TEXT("time: execution time (in seconds)\r\n"));
	_tprintf(TEXT("percentage: CPU usage %\r\n"));
	_tprintf(TEXT("priority: thread priority (255 lowest - 251 default app - 0 highest\r\n"));
	return -1;
}

int _tmain(int argc, TCHAR *argv[], TCHAR *envp[])
{
	if (argc!=4)
		return printUsage();

	DWORD time=_ttoi(argv[1]);
	DWORD percentage=_ttoi(argv[2]);
	DWORD priority=_ttoi(argv[3]);

	if ((percentage<0)||(percentage>100))
		return printUsage();

	if ((priority<0)||(priority>255))
		return printUsage();

	DWORD cputime;
	DWORD quantum;
	
	quantum=CeGetThreadQuantum(GetCurrentThread());
	cputime=(quantum*percentage)/100;

	_tprintf(TEXT("LoadCPU running for %d seconds using %d milliseconds of %dms quantum"),time,cputime,quantum);

	CeSetThreadPriority(GetCurrentThread(),priority);

	// ensures that we are going to have a full quantum to use
	Sleep(0);

	DWORD start=GetTickCount();

	while (GetTickCount()-start<time*1000)
	{
		DWORD curtick=GetTickCount();
	
		while (GetTickCount()-curtick<cputime);

		Sleep(quantum-cputime);
	}

    return 0;
}
